<?php

/**
 * Adds Ajax for Clear Stats button
 */
add_action( 'wp_ajax_nopriv_wp_cta_clear_stats_action', 'wp_cta_clear_stats_action' );
add_action( 'wp_ajax_wp_cta_clear_stats_action', 'wp_cta_clear_stats_action' );
function wp_cta_clear_stats_action()
{	
	global $wpdb;

	$newrules = "0";
	$post_id = mysql_real_escape_string($_POST['page_id']);

	$variations = get_post_meta($post_id, 'wp-cta-ab-variations', true);
	if ($variations)
	{
		$variations = explode(",", $variations);
		foreach ($variations as $vid) 
		{
			add_post_meta( $post_id, 'wp-cta-ab-variation-impressions-'.$vid, $newrules, true ) or update_post_meta( $post_id, 'wp-cta-ab-variation-impressions-'.$vid, $newrules );
			add_post_meta( $post_id, 'wp-cta-ab-variation-conversions-'.$vid, $newrules, true ) or update_post_meta( $post_id, 'wp-cta-ab-variation-conversions-'.$vid, $newrules );
		}
	}
	header('HTTP/1.1 200 OK');
}

// Clear Single Stats
add_action( 'wp_ajax_nopriv_wp_cta_clear_stats_single', 'wp_cta_clear_stats_single' );
add_action( 'wp_ajax_wp_cta_clear_stats_single', 'wp_cta_clear_stats_single' );
function wp_cta_clear_stats_single()
{	
	global $wpdb;

	$newrules = "0";
	$post_id = mysql_real_escape_string($_POST['page_id']);
	$vid = $_POST['variation'];

	add_post_meta( $post_id, 'wp-cta-ab-variation-impressions-'.$vid, $newrules, true ) or update_post_meta( $post_id, 'wp-cta-ab-variation-impressions-'.$vid, $newrules );
	add_post_meta( $post_id, 'wp-cta-ab-variation-conversions-'.$vid, $newrules, true ) or update_post_meta( $post_id, 'wp-cta-ab-variation-conversions-'.$vid, $newrules );

	header('HTTP/1.1 200 OK');
}	

/**
 * Adds ajax to record impressions/conversions
 */

add_action('wp_ajax_wp_cta_record_conversion', 'wp_cta_record_conversion_callback');
add_action('wp_ajax_nopriv_wp_cta_record_conversion', 'wp_cta_record_conversion_callback');

function wp_cta_record_conversion_callback() {
	global $wpdb; // this is how you get access to the database
	global $user_ID; 
	$global_record_admin_actions = get_option( 'wp_cta_global_record_admin_actions', '' );
	$role = get_userdata( $user_ID );
	//if ($role->user_level==10)
	//echo "hello";die();
	
	$current_url = trim($_POST['current_url']);
	
	$parts = explode('wp-cta-variation-id=',$current_url);
	if (count($parts)>1)
	{
		$variation_id = $parts[1];
		$variation_id = str_replace('/','',$variation_id);
	}
	else
	{
		$variation_id = 0; 
	}
	
	$page_id = wp_cta_url_to_postid( $current_url );
	
	if (!wp_cta_determine_spider())
	{	
		wp_cta_set_conversions($page_id);
	}
	
	do_action('wp_cta_record_conversion',$page_id, $variation_id);
	
	print $page_id;
	die(); // this is required to return a proper result
	
}

add_action('wp_ajax_wp_cta_record_impression', 'wp_cta_record_impression_callback');
add_action('wp_ajax_nopriv_wp_cta_record_impression', 'wp_cta_record_impression_callback');

function wp_cta_record_impression_callback() {
	global $wpdb; // this is how you get access to the database
	global $user_ID; 
	
	$global_record_admin_actions = get_option( 'wp_cta_global_record_admin_actions', '' );

	$role = get_userdata( $user_ID );

	$current_url = trim($_POST['current_url']);
	$variation_id = $_POST['variation_id'];
	$page_id = wp_cta_url_to_postid( $current_url );

	
	if ( $disable_admin_tracking && current_user_can( 'manage_options' ) )
	{
		echo "admin tracking disabled";
		die();
	}
	
	if (!wp_cta_determine_spider() )
	{	
		wp_cta_set_page_views($page_id);		
	}
	
	do_action('wp_cta_record_impression',$page_id,$variation_id);
	
	print $page_id;
	die();
	
}

add_action('wp_ajax_wp_cta_store_lead', 'wp_cta_store_lead_callback');
add_action('wp_ajax_nopriv_wp_cta_store_lead', 'wp_cta_store_lead_callback');

function wp_cta_store_lead_callback() 
{
	
	
	if (isset( $_POST['emailTo'])&&!empty( $_POST['emailTo'])&&strstr($_POST['emailTo'],'@'))
	{
		// Grab form values
		$title = $_POST['emailTo'];
		$content =	$_POST['first_name'];
		$wp_lead_uid = $_POST['wp_lead_uid'];
		$raw_post_values_json = $_POST['raw_post_values_json'];
	
		//echo 'here';
		global $user_ID, $wpdb;
		$wordpress_date_time = $timezone_format = _x('Y-m-d G:i:s T', 'timezone date format');
		$wordpress_date_time =  date_i18n($timezone_format);
		
		(isset(	$_POST['first_name'] )) ? $first_name = $_POST['first_name'] : $first_name = "";
		(isset(	$_POST['last_name'] )) ? $last_name = $_POST['last_name'] : $last_name = "";
		(isset(	$_SERVER['REMOTE_ADDR'] )) ? $ip_address = $_SERVER['REMOTE_ADDR'] : $ip_address = "undefined";
		(isset(	$_POST['nature'] )) ? $nature = $_POST['nature'] : $nature = 0;
		(isset(	$_POST['wp_lead_uid'] )) ? $wp_lead_id = $_POST['wp_lead_uid'] : $wp_lead_id = "null";
		(isset(	$_POST['wp_cta_id'] )) ? $wp_cta_id = $_POST['wp_cta_id'] : $wp_cta_id = 0;
		(isset(	$_POST['wp_cta_v'] )) ? $wp_cta_variation = $_POST['wp_cta_v'] : $wp_cta_variation = 0;
		
		do_action('wp_cta_store_lead_pre');
		
		$query = $wpdb->prepare(
			'SELECT ID FROM ' . $wpdb->posts . '
			WHERE post_title = %s
			AND post_type = \'wp-lead\'',
			$_POST['emailTo']
		);
		$wpdb->query( $query );

		if ( $wpdb->num_rows ) {
			// If lead exists add data/append data to it
			$post_ID = $wpdb->get_var( $query );
			//echo "here";
			//echo $post_ID;
			$meta = get_post_meta( $post_ID, 'times', TRUE );			
			$meta++;
			
			if ($wp_cta_id)
			{
				$conversion_data = get_post_meta( $post_ID, 'wpleads_conversion_data', TRUE );
				$conversion_data = json_decode($conversion_data,true);
				$conversion_data[$meta]['id'] = $wp_cta_id;
				$conversion_data[$meta]['variation'] = $wp_cta_variation;
				$conversion_data[$meta]['datetime'] = $wordpress_date_time;
				$conversion_data = json_encode($conversion_data);
			}
			
			update_post_meta( $post_ID, 'times', $meta );
			update_post_meta( $post_ID, 'wpleads_email_address', $title );
			
			if (!empty($user_ID))
				update_post_meta( $post_ID, 'wpleads_wordpress_user_id', $user_ID );				
			if (!empty($first_name))
				update_post_meta( $post_ID, 'wpleads_first_name', $first_name );
			if (!empty($last_name))
				update_post_meta( $post_ID, 'wpleads_last_name', $last_name );
			if (!empty($wp_lead_id))
				update_post_meta( $post_ID, 'wp_leads_uid', $wp_lead_id );
				
			update_post_meta( $post_ID, 'wpleads_ip_address', $ip_address );
			update_post_meta( $post_ID, 'wpleads_conversion_data', $conversion_data );
			update_post_meta( $post_ID, 'wpleads_wp_call_to_action_'.$wp_cta_id, 1 );
			
			do_action('wpleads_after_conversion_lead_update',$post_ID);
		
		} else { 
			// If lead doesn't exist create it
			$post = array(
				'post_title'		=> $title, 
				 //'post_content'		=> $json,
				'post_status'		=> 'publish',
				'post_type'		=> 'wp-lead',
				'post_author'		=> 1
			);
			
			//$post = add_filter('wp_cta_leads_post_vars',$post);
			
			if ($wp_cta_id)
			{			
				$conversion_data[1]['id'] = $wp_cta_id;
				$conversion_data[1]['variation'] = $wp_cta_variation;
				$conversion_data[1]['datetime'] = $wordpress_date_time;
				$conversion_data[1]['first_time'] = 1;					
				$conversion_data = json_encode($conversion_data);
			}
			

			$post_ID = wp_insert_post($post);
			update_post_meta( $post_ID, 'times', 1 );
			update_post_meta( $post_ID, 'wpleads_wordpress_user_id', $user_ID );
			update_post_meta( $post_ID, 'wpleads_email_address', $title );
			update_post_meta( $post_ID, 'wpleads_first_name', $first_name);
			update_post_meta( $post_ID, 'wpleads_last_name', $last_name);
			update_post_meta( $post_ID, 'wpleads_ip_address', $ip_address );
			update_post_meta( $post_ID, 'wp_leads_uid', $wp_lead_id );
			update_post_meta( $post_ID, 'wpleads_conversion_data', $conversion_data );
			update_post_meta( $post_ID, 'wpleads_wp_call_to_action_'.$wp_cta_id, 1 );
			
			$geo_array = unserialize(wp_cta_remote_connect('http://www.geoplugin.net/php.gp?ip='.$ip_address));
			
			
			(isset($geo_array['geoplugin_areaCode'])) ? update_post_meta( $post_ID, 'wpleads_areaCode', $geo_array['geoplugin_areaCode'] ) : null;
			(isset($geo_array['geoplugin_city'])) ? update_post_meta( $post_ID, 'wpleads_city', $geo_array['geoplugin_city'] ) : null;
			(isset($geo_array['geoplugin_regionName'])) ? update_post_meta( $post_ID, 'wpleads_region_name', $geo_array['geoplugin_regionName'] ) : null;
			(isset($geo_array['geoplugin_regionCode'])) ? update_post_meta( $post_ID, 'wpleads_region_code', $geo_array['geoplugin_regionCode'] ) : null;
			(isset($geo_array['geoplugin_countryName'])) ? update_post_meta( $post_ID, 'wpleads_country_name', $geo_array['geoplugin_countryName'] ) : null;
			(isset($geo_array['geoplugin_countryCode'])) ? update_post_meta( $post_ID, 'wpleads_country_code', $geo_array['geoplugin_countryCode'] ) : null;
			(isset($geo_array['geoplugin_latitude'])) ? update_post_meta( $post_ID, 'wpleads_latitude', $geo_array['geoplugin_latitude'] ) : null;
			(isset($geo_array['geoplugin_longitude'])) ? update_post_meta( $post_ID, 'wpleads_longitude', $geo_array['geoplugin_longitude'] ) : null;
			(isset($geo_array['geoplugin_currencyCode'])) ? update_post_meta( $post_ID, 'wpleads_currency_code', $geo_array['geoplugin_currencyCode'] ) : null;
			(isset($geo_array['geoplugin_currencySymbol_UTF8'])) ? update_post_meta( $post_ID, 'wpleads_currency_symbol', $geo_array['geoplugin_currencySymbol_UTF8'] ) : null;
			
			do_action('wpleads_after_conversion_lead_insert',$post_ID);
		
		}

		$timezone_format = _x('Y-m-d G:i:s', 'timezone date format');
		$wordpress_date_time =  date_i18n($timezone_format);
		$data['wp_cta_id'] = $wp_cta_id;
		$data['lead_id'] = $post_ID;
		$data['first_name'] = $first_name;
		$data['last_name'] = $last_name;
		$data['email'] = $title;
		$data['wp_lead_uid'] = $wp_lead_id;
		$data['raw_post_values_json'] = $raw_post_values_json;
		
		do_action('wp_cta_store_lead_post', $data );
		setcookie('wp_lead_id' , $post_ID, time() + (20 * 365 * 24 * 60 * 60),'/');
		echo $post_ID;
		die();
	}
}


/**
 * ADD AJAX FOR METABOX TEMPLATE SWITCHING
 */
 
add_action( 'wp_ajax_nopriv_wp_cta_get_template_meta', 'wp_cta_get_template_meta' );
add_action( 'wp_ajax_wp_cta_get_template_meta', 'wp_cta_get_template_meta' );
function wp_cta_get_template_meta()
{
	global $wpdb;
	$current_template = $_POST['selected_template'];
	$post_id = $_POST['post_id'];
	$post = get_post($post_id);
	
	//echo $current_template; exit;
	$key['args']['key'] = $current_template;
	
	wp_cta_show_metabox($post,$key);
	die();
}


/**
 * Add ajax for post meta save options
 */
add_action( 'wp_ajax_nopriv_wp_wp_call_to_action_meta_save', 'wp_wp_call_to_action_meta_save' );
add_action( 'wp_ajax_wp_wp_call_to_action_meta_save', 'wp_wp_call_to_action_meta_save' );
function wp_wp_call_to_action_meta_save()
{
	global $wpdb;
	if ( !wp_verify_nonce( $_POST['nonce'], "wp-call-to-action-meta-nonce")) {
		 exit("Wrong nonce");
	}
	$new_meta_val = $_POST['new_meta_val'];
	$meta_id = $_POST['meta_id'];
	$post_id = mysql_real_escape_string($_POST['page_id']);
	if ($meta_id === "main_title") 
	{
		$my_post = array();
		$my_post['ID'] = $post_id;
		$my_post['post_title'] = $new_meta_val;
		// Update the post into the database
		wp_update_post( $my_post );
	}
	if ($meta_id === "the_content") 
	{
		$title_save = get_post_meta($post_id, "wp-cta-main-headline", true); // fix content from removing title
		$my_post = array();
		$my_post['ID'] = $post_id;
		$my_post['post_content'] = $new_meta_val;
		// Update the post into the database
		wp_update_post( $my_post );
		add_post_meta( $post_id, "wp-cta-main-headline", $title_save, true ) or update_post_meta( $post_id, "wp-cta-main-headline", $title_save ); // fix main headline removal
	} 
	else 
	{
	  add_post_meta( $post_id, $meta_id, $new_meta_val, true ) or update_post_meta( $post_id, $meta_id, $new_meta_val );
	}
	
	header('HTTP/1.1 200 OK');
}